/* VisPro/REXX RC front-end by Salvador Parra Camacho */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

parse source . . prg_exe

parse arg rc_file exe_file

current_dir = directory()

rc_args = ''

prg_exe_bas = substr(prg_exe, lastpos('\', prg_exe)+1)
prg_exe_nam = delstr(prg_exe_bas, lastpos('.', prg_exe_bas))

if translate(prg_exe_nam) = 'RC' then
	resource_compiler = 'RCC.EXE'
else
	resource_compiler = 'RC.EXE'

prg_cfg = current_dir||'\vpr.cfg'

call SysFileTree current_dir||'\Main', main_exists, 'DO'

if stream(prg_cfg,'c','query exists') = '' | main_exists.0 = '0' then
	do
	'@'||resource_compiler||' '||rc_file exe_file
	exit rc
	end

run_cmd = stream('_RUN.CMD', 'C', 'QUERY EXISTS')
ascii = _isascii()

if SysSearchPath('PATH', 'pmpopup2.exe') <> '' then
	'@pmpopup2 "~~Preprocessing REXX and resources" "VisPro/REXX RC front-end" /F:"Helv.8" /T:1 /A:C'

call _rexx '[RC:pre]'

select
	when run_cmd = '' then
		call _rexx '[RC:pre:macro]'
	when ascii = '0' then
		call _rexx '[RC:pre:encrypt|tokenize]'
	otherwise
		call _rexx '[RC:pre:none]'
end

if rc_args = '' then
	'@'||resource_compiler rc_file exe_file
else
	'@'||resource_compiler rc_args rc_file exe_file

rc_rc = rc

if SysSearchPath('PATH', 'pmpopup2.exe') <> '' then
	'@pmpopup2 "~~Postprocessing" "VisPro/REXX RC front-end" /F:"Helv.8" /T:1 /A:C'

select
	when run_cmd = '' then
		call _rexx '[RC:post:macro]'
	when ascii = '0' then
		call _rexx '[RC:post:encrypt|tokenize]'
	otherwise
		call _rexx '[RC:post:none]'
end

call _rexx '[RC:post]'

exit rc_rc

_rexx: procedure expose prg_cfg rc_args rc_file exe_file rc_rc

parse arg mode

rx_code = ''

do while lines(prg_cfg) > 0
	current_line = strip(linein(prg_cfg),'T')
	first_char = left(current_line,1)
	if current_line = mode then
		do until first_char = '[' | lines(prg_cfg) = '0'
			current_line = strip(linein(prg_cfg),'T')
			first_char = left(current_line,1)
			select
			when first_char = ';' then
				nop
			when first_char = '[' then
				nop
			otherwise
				rx_code = rx_code||';'||current_line
			end
		end
end

call lineout prg_cfg

interpret rx_code

return

_isascii: procedure

do 3
line = linein('_RUN.CMD')
line = strip(line, , '0A'x)
line = strip(line, , '0D'x)

do i = 1 to length(line)
	dec_char = c2d(substr(line, i, 1))
	if dec_char < '32' & dec_char <> '9' then
		do
		call charout '_RUN.CMD'
		return 0
		end
end
end

call charout '_RUN.CMD'

return 1

_rmresources: procedure

rc_file = 'DELETE.ME1'
rc_data = ''
crlf = '0D0A'x

parse arg resource

if resource = '' then
	return

do while lines(rc_file) > 0
	line = linein(rc_file)
	select
	when abbrev(line, 'DLGTEMPLATE') = '1' & (resource = 'ALL' | resource = 'DIALOG') then
		do until abbrev(line, 'END') = '1' | lines(rc_file) = '0'
			line = linein(rc_file)
		end
	when abbrev(line, 'HELPSUBTABLE') = '1' & (resource = 'ALL' | resource = 'HELP') then
		do until abbrev(line, 'END') = '1' | lines(rc_file) = '0'
			line = linein(rc_file)
		end
	when abbrev(line, 'HELPTABLE') = '1' & (resource = 'ALL' | resource = 'HELP') then
		do until abbrev(line, '  END') = '1' | lines(rc_file) = '0'
			line = linein(rc_file)
		end
	when abbrev(line, 'RCDATA') = '1' & (resource = 'ALL' | resource = 'RCDATA') then
		do until abbrev(line, '  END') = '1' | lines(rc_file) = '0'
			line = linein(rc_file)
		end
	otherwise
		if rc_data = '' then
			rc_data = line
		else
			rc_data = rc_data||crlf||line
	end
end

call lineout rc_file

call SysFileDelete rc_file

call charout rc_file, rc_data
call charout rc_file

return

_savetemp: procedure

if stream('_RUN.CMD', 'C', 'QUERY EXISTS') <> '' then
	'@copy _RUN.CMD _NORUN.CMD'
do i = 1 to 4
	if stream('DELETE.ME'||i, 'C', 'QUERY EXISTS') <> '' then
		'@type DELETE.ME'||i||' > NODELETE.ME'||i
end

return

/* The following procedure is based in the classic Mike Cowlishaw's CHANGE.REX */

_strrpl: procedure

parse arg file, search, replace

if file = '' | search = '' | replace = '' then
	return

old_data = charin(file, 1, chars(file))
call charout file

new_data = ''

do while pos(search, old_data) <> 0
	parse var old_data prefix (search) old_data
	new_data = new_data||prefix||replace
end

new_data = new_data||old_data

call SysFileDelete file

call charout file, new_data
call charout file

return